# coding: utf-8

"""
Root Signals API

Root Signals JSON API provides a way to access Root Signals using provisioned API token

The version of the OpenAPI document: 1.0.0 (latest)
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictBool
from typing_extensions import Self

from root.generated.openapi_aclient.models.validator_result import ValidatorResult


class Validation(BaseModel):
    """
    Validation
    """  # noqa: E501

    is_valid: Optional[StrictBool] = None
    validator_results: Optional[List[ValidatorResult]]
    __properties: ClassVar[List[str]] = ["is_valid", "validator_results"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Validation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in validator_results (list)
        _items = []
        if self.validator_results:
            for _item in self.validator_results:
                if _item:
                    _items.append(_item.to_dict())
            _dict["validator_results"] = _items
        # set to None if validator_results (nullable) is None
        # and model_fields_set contains the field
        if self.validator_results is None and "validator_results" in self.model_fields_set:
            _dict["validator_results"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Validation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "is_valid": obj.get("is_valid"),
                "validator_results": [ValidatorResult.from_dict(_item) for _item in obj["validator_results"]]
                if obj.get("validator_results") is not None
                else None,
            }
        )
        return _obj
