# root.generated.openapi-client
Root Signals JSON API provides a way to access Root Signals using provisioned API token

The `root.generated.openapi_client` package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0 (latest)
- Package version: 1.0.0
- Generator version: 7.4.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage

This python library package is generated without supporting files like setup.py or requirements files

To be able to use it, you will need these dependencies in your own package that uses this library:

* urllib3 >= 1.25.3
* python-dateutil
* pydantic

## Getting Started

In your own code, to use this library to connect and interact with root.generated.openapi-client,
you can run the following:

```python

import root.generated.openapi_client
from root.generated.openapi_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to https://api.app.rootsignals.ai
# See configuration.py for a list of all supported configuration parameters.
configuration = root.generated.openapi_client.Configuration(
    host = "https://api.app.rootsignals.ai"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: publicApiKey
configuration.api_key['publicApiKey'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['publicApiKey'] = 'Bearer'


# Enter a context with an instance of the API client
with root.generated.openapi_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = root.generated.openapi_client.BetaApi(api_client)
    judge_request = root.generated.openapi_client.JudgeRequest() # JudgeRequest | 

    try:
        api_response = api_instance.beta_judges_create(judge_request)
        print("The response of BetaApi->beta_judges_create:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling BetaApi->beta_judges_create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.app.rootsignals.ai*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*BetaApi* | [**beta_judges_create**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_create) | **POST** /beta/judges/ | 
*BetaApi* | [**beta_judges_destroy**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_destroy) | **DELETE** /beta/judges/{id}/ | 
*BetaApi* | [**beta_judges_duplicate_create**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_duplicate_create) | **POST** /beta/judges/{id}/duplicate/ | 
*BetaApi* | [**beta_judges_execute_create**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_execute_create) | **POST** /beta/judges/{judge_id}/execute/ | 
*BetaApi* | [**beta_judges_list**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_list) | **GET** /beta/judges/ | 
*BetaApi* | [**beta_judges_partial_update**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_partial_update) | **PATCH** /beta/judges/{id}/ | 
*BetaApi* | [**beta_judges_retrieve**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_retrieve) | **GET** /beta/judges/{id}/ | 
*BetaApi* | [**beta_judges_update**](root/generated/openapi_client/docs/BetaApi.md#beta_judges_update) | **PUT** /beta/judges/{id}/ | 
*V1Api* | [**change_evaluator_status**](root/generated/openapi_client/docs/V1Api.md#change_evaluator_status) | **POST** /v1/evaluators/status/{id}/ | 
*V1Api* | [**change_evaluator_status2**](root/generated/openapi_client/docs/V1Api.md#change_evaluator_status2) | **PUT** /v1/evaluators/status/{id}/ | 
*V1Api* | [**create_evaluator**](root/generated/openapi_client/docs/V1Api.md#create_evaluator) | **POST** /v1/evaluators/ | 
*V1Api* | [**delete_evaluator**](root/generated/openapi_client/docs/V1Api.md#delete_evaluator) | **DELETE** /v1/evaluators/{id}/ | 
*V1Api* | [**duplicate_evaluator**](root/generated/openapi_client/docs/V1Api.md#duplicate_evaluator) | **POST** /v1/evaluators/duplicate/{id}/ | 
*V1Api* | [**duplicate_skill**](root/generated/openapi_client/docs/V1Api.md#duplicate_skill) | **POST** /v1/skills/duplicate/{id}/ | 
*V1Api* | [**get_a_list_of_all_versions_of_an_objective**](root/generated/openapi_client/docs/V1Api.md#get_a_list_of_all_versions_of_an_objective) | **GET** /v1/objectives/versions/{id}/ | 
*V1Api* | [**get_evaluator_details**](root/generated/openapi_client/docs/V1Api.md#get_evaluator_details) | **GET** /v1/evaluators/{id}/ | 
*V1Api* | [**list_evaluator_versions**](root/generated/openapi_client/docs/V1Api.md#list_evaluator_versions) | **GET** /v1/evaluators/versions/{id}/ | 
*V1Api* | [**list_evaluators**](root/generated/openapi_client/docs/V1Api.md#list_evaluators) | **GET** /v1/evaluators/ | 
*V1Api* | [**list_skill_versions**](root/generated/openapi_client/docs/V1Api.md#list_skill_versions) | **GET** /v1/skills/versions/{id}/ | 
*V1Api* | [**partial_update_evaluator**](root/generated/openapi_client/docs/V1Api.md#partial_update_evaluator) | **PATCH** /v1/evaluators/{id}/ | 
*V1Api* | [**update_evaluator**](root/generated/openapi_client/docs/V1Api.md#update_evaluator) | **PUT** /v1/evaluators/{id}/ | 
*V1Api* | [**v1_chats_execute_create**](root/generated/openapi_client/docs/V1Api.md#v1_chats_execute_create) | **POST** /v1/chats/{chat_id}/execute/ | 
*V1Api* | [**v1_chats_initiate_create**](root/generated/openapi_client/docs/V1Api.md#v1_chats_initiate_create) | **POST** /v1/chats/initiate/ | 
*V1Api* | [**v1_chats_initiate_create2**](root/generated/openapi_client/docs/V1Api.md#v1_chats_initiate_create2) | **POST** /v1/chats/{chat_id}/initiate/ | 
*V1Api* | [**v1_chats_list**](root/generated/openapi_client/docs/V1Api.md#v1_chats_list) | **GET** /v1/chats/ | 
*V1Api* | [**v1_chats_messages_status_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_chats_messages_status_retrieve) | **GET** /v1/chats/{chat_id}/messages/{correlation_id}/status/ | 
*V1Api* | [**v1_chats_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_chats_retrieve) | **GET** /v1/chats/{chat_id}/ | 
*V1Api* | [**v1_datasets_create**](root/generated/openapi_client/docs/V1Api.md#v1_datasets_create) | **POST** /v1/datasets/ | 
*V1Api* | [**v1_datasets_destroy**](root/generated/openapi_client/docs/V1Api.md#v1_datasets_destroy) | **DELETE** /v1/datasets/{id}/ | 
*V1Api* | [**v1_datasets_list**](root/generated/openapi_client/docs/V1Api.md#v1_datasets_list) | **GET** /v1/datasets/ | 
*V1Api* | [**v1_datasets_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_datasets_retrieve) | **GET** /v1/datasets/{id}/ | 
*V1Api* | [**v1_datasets_status_update**](root/generated/openapi_client/docs/V1Api.md#v1_datasets_status_update) | **PUT** /v1/datasets/status/{id}/ | 
*V1Api* | [**v1_document_parsing_create**](root/generated/openapi_client/docs/V1Api.md#v1_document_parsing_create) | **POST** /v1/document-parsing/ | 
*V1Api* | [**v1_evaluators_calibrate_create**](root/generated/openapi_client/docs/V1Api.md#v1_evaluators_calibrate_create) | **POST** /v1/evaluators/calibrate/ | 
*V1Api* | [**v1_evaluators_calibrate_create2**](root/generated/openapi_client/docs/V1Api.md#v1_evaluators_calibrate_create2) | **POST** /v1/evaluators/calibrate/{id} | 
*V1Api* | [**v1_evaluators_execute_create**](root/generated/openapi_client/docs/V1Api.md#v1_evaluators_execute_create) | **POST** /v1/evaluators/execute/{id}/ | 
*V1Api* | [**v1_execution_logs_list**](root/generated/openapi_client/docs/V1Api.md#v1_execution_logs_list) | **GET** /v1/execution-logs/ | 
*V1Api* | [**v1_execution_logs_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_execution_logs_retrieve) | **GET** /v1/execution-logs/{log_id}/ | 
*V1Api* | [**v1_models_create**](root/generated/openapi_client/docs/V1Api.md#v1_models_create) | **POST** /v1/models/ | 
*V1Api* | [**v1_models_destroy**](root/generated/openapi_client/docs/V1Api.md#v1_models_destroy) | **DELETE** /v1/models/{id}/ | 
*V1Api* | [**v1_models_list**](root/generated/openapi_client/docs/V1Api.md#v1_models_list) | **GET** /v1/models/ | 
*V1Api* | [**v1_models_partial_update**](root/generated/openapi_client/docs/V1Api.md#v1_models_partial_update) | **PATCH** /v1/models/{id}/ | 
*V1Api* | [**v1_models_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_models_retrieve) | **GET** /v1/models/{id}/ | 
*V1Api* | [**v1_models_update**](root/generated/openapi_client/docs/V1Api.md#v1_models_update) | **PUT** /v1/models/{id}/ | 
*V1Api* | [**v1_objectives_create**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_create) | **POST** /v1/objectives/ | 
*V1Api* | [**v1_objectives_destroy**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_destroy) | **DELETE** /v1/objectives/{id}/ | 
*V1Api* | [**v1_objectives_list**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_list) | **GET** /v1/objectives/ | 
*V1Api* | [**v1_objectives_objectives_execute_create**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_objectives_execute_create) | **POST** /v1/objectives/objectives/{objective_id}/execute/ | 
*V1Api* | [**v1_objectives_partial_update**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_partial_update) | **PATCH** /v1/objectives/{id}/ | 
*V1Api* | [**v1_objectives_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_retrieve) | **GET** /v1/objectives/{id}/ | 
*V1Api* | [**v1_objectives_update**](root/generated/openapi_client/docs/V1Api.md#v1_objectives_update) | **PUT** /v1/objectives/{id}/ | 
*V1Api* | [**v1_skills_calibrate_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_calibrate_create) | **POST** /v1/skills/calibrate/ | 
*V1Api* | [**v1_skills_calibrate_create2**](root/generated/openapi_client/docs/V1Api.md#v1_skills_calibrate_create2) | **POST** /v1/skills/calibrate/{id} | 
*V1Api* | [**v1_skills_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_create) | **POST** /v1/skills/ | 
*V1Api* | [**v1_skills_destroy**](root/generated/openapi_client/docs/V1Api.md#v1_skills_destroy) | **DELETE** /v1/skills/{id}/ | 
*V1Api* | [**v1_skills_evaluator_execute_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_evaluator_execute_create) | **POST** /v1/skills/evaluator/execute/{skill_id}/ | 
*V1Api* | [**v1_skills_execute_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_execute_create) | **POST** /v1/skills/execute/{id}/ | 
*V1Api* | [**v1_skills_execute_validators_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_execute_validators_create) | **POST** /v1/skills/execute-validators/{id}/ | 
*V1Api* | [**v1_skills_list**](root/generated/openapi_client/docs/V1Api.md#v1_skills_list) | **GET** /v1/skills/ | 
*V1Api* | [**v1_skills_openai_chat_completions_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_openai_chat_completions_create) | **POST** /v1/skills/openai/{skill_id}/chat/completions | 
*V1Api* | [**v1_skills_partial_update**](root/generated/openapi_client/docs/V1Api.md#v1_skills_partial_update) | **PATCH** /v1/skills/{id}/ | 
*V1Api* | [**v1_skills_retrieve**](root/generated/openapi_client/docs/V1Api.md#v1_skills_retrieve) | **GET** /v1/skills/{id}/ | 
*V1Api* | [**v1_skills_status_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_status_create) | **POST** /v1/skills/status/{id}/ | 
*V1Api* | [**v1_skills_status_update**](root/generated/openapi_client/docs/V1Api.md#v1_skills_status_update) | **PUT** /v1/skills/status/{id}/ | 
*V1Api* | [**v1_skills_test_create**](root/generated/openapi_client/docs/V1Api.md#v1_skills_test_create) | **POST** /v1/skills/test/ | 
*V1Api* | [**v1_skills_test_create2**](root/generated/openapi_client/docs/V1Api.md#v1_skills_test_create2) | **POST** /v1/skills/test/{id} | 
*V1Api* | [**v1_skills_update**](root/generated/openapi_client/docs/V1Api.md#v1_skills_update) | **PUT** /v1/skills/{id}/ | 


## Documentation For Models

 - [Chat](root/generated/openapi_client/docs/Chat.md)
 - [ChatCreateRequest](root/generated/openapi_client/docs/ChatCreateRequest.md)
 - [ChatDetail](root/generated/openapi_client/docs/ChatDetail.md)
 - [ChatExecutionRequestRequest](root/generated/openapi_client/docs/ChatExecutionRequestRequest.md)
 - [ChatExecutionResult](root/generated/openapi_client/docs/ChatExecutionResult.md)
 - [ChatMessage](root/generated/openapi_client/docs/ChatMessage.md)
 - [DataLoader](root/generated/openapi_client/docs/DataLoader.md)
 - [DataLoaderRequest](root/generated/openapi_client/docs/DataLoaderRequest.md)
 - [DataLoaderTypeEnum](root/generated/openapi_client/docs/DataLoaderTypeEnum.md)
 - [DataSetCreate](root/generated/openapi_client/docs/DataSetCreate.md)
 - [DataSetCreateRequest](root/generated/openapi_client/docs/DataSetCreateRequest.md)
 - [DataSetList](root/generated/openapi_client/docs/DataSetList.md)
 - [DataSetType](root/generated/openapi_client/docs/DataSetType.md)
 - [DatasetRangeRequest](root/generated/openapi_client/docs/DatasetRangeRequest.md)
 - [DocumentParseRequestRequest](root/generated/openapi_client/docs/DocumentParseRequestRequest.md)
 - [DocumentParseResponse](root/generated/openapi_client/docs/DocumentParseResponse.md)
 - [DocumentTypeEnum](root/generated/openapi_client/docs/DocumentTypeEnum.md)
 - [Evaluator](root/generated/openapi_client/docs/Evaluator.md)
 - [EvaluatorCalibrationOutput](root/generated/openapi_client/docs/EvaluatorCalibrationOutput.md)
 - [EvaluatorCalibrationResult](root/generated/openapi_client/docs/EvaluatorCalibrationResult.md)
 - [EvaluatorDemonstrations](root/generated/openapi_client/docs/EvaluatorDemonstrations.md)
 - [EvaluatorDemonstrationsRequest](root/generated/openapi_client/docs/EvaluatorDemonstrationsRequest.md)
 - [EvaluatorExecutionFunctionParameterPropertyRequest](root/generated/openapi_client/docs/EvaluatorExecutionFunctionParameterPropertyRequest.md)
 - [EvaluatorExecutionFunctionParameterRequest](root/generated/openapi_client/docs/EvaluatorExecutionFunctionParameterRequest.md)
 - [EvaluatorExecutionFunctionParameterTypeEnum](root/generated/openapi_client/docs/EvaluatorExecutionFunctionParameterTypeEnum.md)
 - [EvaluatorExecutionFunctionRequest](root/generated/openapi_client/docs/EvaluatorExecutionFunctionRequest.md)
 - [EvaluatorExecutionFunctionsRequest](root/generated/openapi_client/docs/EvaluatorExecutionFunctionsRequest.md)
 - [EvaluatorExecutionFunctionsTypeEnum](root/generated/openapi_client/docs/EvaluatorExecutionFunctionsTypeEnum.md)
 - [EvaluatorExecutionRequest](root/generated/openapi_client/docs/EvaluatorExecutionRequest.md)
 - [EvaluatorExecutionResult](root/generated/openapi_client/docs/EvaluatorExecutionResult.md)
 - [EvaluatorListOutput](root/generated/openapi_client/docs/EvaluatorListOutput.md)
 - [EvaluatorReference](root/generated/openapi_client/docs/EvaluatorReference.md)
 - [EvaluatorReferenceRequest](root/generated/openapi_client/docs/EvaluatorReferenceRequest.md)
 - [EvaluatorRequest](root/generated/openapi_client/docs/EvaluatorRequest.md)
 - [EvaluatorResult](root/generated/openapi_client/docs/EvaluatorResult.md)
 - [ExecutionLogDetails](root/generated/openapi_client/docs/ExecutionLogDetails.md)
 - [ExecutionLogDetailsObjective](root/generated/openapi_client/docs/ExecutionLogDetailsObjective.md)
 - [ExecutionLogDetailsSkill](root/generated/openapi_client/docs/ExecutionLogDetailsSkill.md)
 - [ExecutionLogList](root/generated/openapi_client/docs/ExecutionLogList.md)
 - [ExecutionLogListSkill](root/generated/openapi_client/docs/ExecutionLogListSkill.md)
 - [ID](root/generated/openapi_client/docs/ID.md)
 - [InputVariable](root/generated/openapi_client/docs/InputVariable.md)
 - [InputVariableRequest](root/generated/openapi_client/docs/InputVariableRequest.md)
 - [Judge](root/generated/openapi_client/docs/Judge.md)
 - [JudgeExecutionRequest](root/generated/openapi_client/docs/JudgeExecutionRequest.md)
 - [JudgeExecutionResponse](root/generated/openapi_client/docs/JudgeExecutionResponse.md)
 - [JudgeList](root/generated/openapi_client/docs/JudgeList.md)
 - [JudgeOwner](root/generated/openapi_client/docs/JudgeOwner.md)
 - [JudgeRequest](root/generated/openapi_client/docs/JudgeRequest.md)
 - [JudgeStatusEnum](root/generated/openapi_client/docs/JudgeStatusEnum.md)
 - [Model](root/generated/openapi_client/docs/Model.md)
 - [ModelList](root/generated/openapi_client/docs/ModelList.md)
 - [ModelParams](root/generated/openapi_client/docs/ModelParams.md)
 - [ModelParamsRequest](root/generated/openapi_client/docs/ModelParamsRequest.md)
 - [ModelRequest](root/generated/openapi_client/docs/ModelRequest.md)
 - [NestedEvaluator](root/generated/openapi_client/docs/NestedEvaluator.md)
 - [NestedEvaluatorRequest](root/generated/openapi_client/docs/NestedEvaluatorRequest.md)
 - [NestedObjectiveEvaluator](root/generated/openapi_client/docs/NestedObjectiveEvaluator.md)
 - [NestedObjectiveEvaluatorRequest](root/generated/openapi_client/docs/NestedObjectiveEvaluatorRequest.md)
 - [NestedObjectiveList](root/generated/openapi_client/docs/NestedObjectiveList.md)
 - [NestedUserDetails](root/generated/openapi_client/docs/NestedUserDetails.md)
 - [NestedVectorObjective](root/generated/openapi_client/docs/NestedVectorObjective.md)
 - [NestedVectorObjectiveRequest](root/generated/openapi_client/docs/NestedVectorObjectiveRequest.md)
 - [Objective](root/generated/openapi_client/docs/Objective.md)
 - [ObjectiveExecutionRequest](root/generated/openapi_client/docs/ObjectiveExecutionRequest.md)
 - [ObjectiveList](root/generated/openapi_client/docs/ObjectiveList.md)
 - [ObjectiveRequest](root/generated/openapi_client/docs/ObjectiveRequest.md)
 - [ObjectiveValidator](root/generated/openapi_client/docs/ObjectiveValidator.md)
 - [ObjectiveValidatorRequest](root/generated/openapi_client/docs/ObjectiveValidatorRequest.md)
 - [OpenAIChatCompletionRequest](root/generated/openapi_client/docs/OpenAIChatCompletionRequest.md)
 - [OpenAIMessageRequest](root/generated/openapi_client/docs/OpenAIMessageRequest.md)
 - [PaginatedChatList](root/generated/openapi_client/docs/PaginatedChatList.md)
 - [PaginatedDataSetListList](root/generated/openapi_client/docs/PaginatedDataSetListList.md)
 - [PaginatedEvaluatorList](root/generated/openapi_client/docs/PaginatedEvaluatorList.md)
 - [PaginatedEvaluatorListOutputList](root/generated/openapi_client/docs/PaginatedEvaluatorListOutputList.md)
 - [PaginatedExecutionLogListList](root/generated/openapi_client/docs/PaginatedExecutionLogListList.md)
 - [PaginatedJudgeListList](root/generated/openapi_client/docs/PaginatedJudgeListList.md)
 - [PaginatedModelListList](root/generated/openapi_client/docs/PaginatedModelListList.md)
 - [PaginatedObjectiveList](root/generated/openapi_client/docs/PaginatedObjectiveList.md)
 - [PaginatedObjectiveListList](root/generated/openapi_client/docs/PaginatedObjectiveListList.md)
 - [PaginatedSkillList](root/generated/openapi_client/docs/PaginatedSkillList.md)
 - [PaginatedSkillListOutputList](root/generated/openapi_client/docs/PaginatedSkillListOutputList.md)
 - [PatchedEvaluatorRequest](root/generated/openapi_client/docs/PatchedEvaluatorRequest.md)
 - [PatchedJudgeRequest](root/generated/openapi_client/docs/PatchedJudgeRequest.md)
 - [PatchedModelRequest](root/generated/openapi_client/docs/PatchedModelRequest.md)
 - [PatchedObjectiveRequest](root/generated/openapi_client/docs/PatchedObjectiveRequest.md)
 - [PatchedSkillRequest](root/generated/openapi_client/docs/PatchedSkillRequest.md)
 - [Provider](root/generated/openapi_client/docs/Provider.md)
 - [ReferenceVariable](root/generated/openapi_client/docs/ReferenceVariable.md)
 - [ReferenceVariableDynamicDatasetsRequest](root/generated/openapi_client/docs/ReferenceVariableDynamicDatasetsRequest.md)
 - [ReferenceVariableRequest](root/generated/openapi_client/docs/ReferenceVariableRequest.md)
 - [ResponseFormatEnum](root/generated/openapi_client/docs/ResponseFormatEnum.md)
 - [RoleEnum](root/generated/openapi_client/docs/RoleEnum.md)
 - [Skill](root/generated/openapi_client/docs/Skill.md)
 - [SkillExecutionRequest](root/generated/openapi_client/docs/SkillExecutionRequest.md)
 - [SkillExecutionResult](root/generated/openapi_client/docs/SkillExecutionResult.md)
 - [SkillExecutionValidatorResult](root/generated/openapi_client/docs/SkillExecutionValidatorResult.md)
 - [SkillListOutput](root/generated/openapi_client/docs/SkillListOutput.md)
 - [SkillRequest](root/generated/openapi_client/docs/SkillRequest.md)
 - [SkillTestDataRequest](root/generated/openapi_client/docs/SkillTestDataRequest.md)
 - [SkillTestDataRequestDatasetRange](root/generated/openapi_client/docs/SkillTestDataRequestDatasetRange.md)
 - [SkillTestInputRequest](root/generated/openapi_client/docs/SkillTestInputRequest.md)
 - [SkillTestOutput](root/generated/openapi_client/docs/SkillTestOutput.md)
 - [SkillTypeEnum](root/generated/openapi_client/docs/SkillTypeEnum.md)
 - [SkillValidatorExecutionRequest](root/generated/openapi_client/docs/SkillValidatorExecutionRequest.md)
 - [StatusChange](root/generated/openapi_client/docs/StatusChange.md)
 - [StatusChangeRequest](root/generated/openapi_client/docs/StatusChangeRequest.md)
 - [StatusChangeStatusEnum](root/generated/openapi_client/docs/StatusChangeStatusEnum.md)
 - [StatusEnum](root/generated/openapi_client/docs/StatusEnum.md)
 - [Validation](root/generated/openapi_client/docs/Validation.md)
 - [ValidationResultStatus](root/generated/openapi_client/docs/ValidationResultStatus.md)
 - [ValidatorExecutionResult](root/generated/openapi_client/docs/ValidatorExecutionResult.md)
 - [ValidatorResult](root/generated/openapi_client/docs/ValidatorResult.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="publicApiKey"></a>
### publicApiKey

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author




